module Core.Types where

import qualified Data.Text.Lazy as LT

import Control.Monad.Reader (MonadIO, MonadReader, ReaderT)
import Data.Text
import GHC.Generics         (Generic)
import Numeric.Natural      (Natural)
import Web.Scotty.Trans     (ScottyT, ActionT)

type PurrApp    a = ScottyT LT.Text ConfigM a
type PurrAction a = ActionT LT.Text ConfigM a

newtype ConfigM a = ConfigM
  { runConfigM :: ReaderT DhallConfig IO a
  } deriving (Applicative, Functor, Monad, MonadIO, MonadReader DhallConfig)

data DhallConfig = DhallConfig
  { environment     :: String
  , applicationHost :: String
  , applicationPort :: Int
  , dbFile          :: String
  , dbKey           :: String
  , linkLength      :: Int
  } deriving (Generic, Show)
