module Feature.Generation.Passwords where

import Core.Types
import Feature.Generation.Shared (rIndex, validChars)

import Control.Monad.Reader (ask, lift, liftIO)
import Data.Char (toLower, toUpper)
import Data.List (singleton)
import System.IO
import System.Random

camelCase :: [Char] -> [Char]
camelCase [] = []
camelCase x = toUpper (head x) : map toLower (tail x)

-- suggestedScheme and its helpers xkcd, oldschool, and gibberish are TODO.
suggestedScheme :: Int -> IO String
suggestedScheme i 
  | i > 23    = xkcd i
  | i > 12    = oldschool i
  | otherwise = gibberish i

xkcd :: Int -> IO String
xkcd i = do
  wOne   <- randomCamel
  wTwo   <- randomCamel
  wThree <- randomCamel
  wFour  <- randomCamel
  return  $ wOne <> wTwo <> wThree <> wFour

oldschool :: Int -> IO String
oldschool i = do
  wOne  <- randomWord
  wTwo  <- randomWord
  return $ wOne <> wTwo

gibberish :: Int -> IO String
gibberish i = return "mf98sgs7bgg%#"

wordList :: IO [String]
wordList = fmap lines (readFile "./src/Feature/Generation/wordlist.txt")

randomWord :: IO String
randomWord = wordList >>= rIndex

randomCamel :: IO String
randomCamel = camelCase <$> randomWord
